Gyoto::Spectrum::Python Class Reference

Loader for Python classes implementing the Spectrum interface. More...

`#include <GyotoPython.h>`

Inheritance diagram for Gyoto::Spectrum::Python:

## Public Types

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > | Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)
| A subcontractor builds an object upon order from the Factory.

## Public Member Functions

virtual Property const * | getProperties () const
| Get list of properties.
| Python (const Python &)
virtual Python * | clone () const
| Cloner.
virtual std::string | module () const
| Return module_.
virtual void | module (const std::string &)
| Set module_ and import the Python module.
virtual std::string | inlineModule () const
| Return inline_module_.
virtual void | inlineModule (const std::string &)
| Set inline_module_ and import the Python module.
virtual std::string | klass () const
| Retrieve class_.
virtual void | klass (const std::string &)
| Set class_ and instantiate the Python class.
virtual std::vector< double > | parameters () const
| Retrieve parameters_.
virtual void | parameters (const std::vector< double > &)
| Set parameters_ and send them to pInstance_.
virtual double | operator() (double nu) const
| I_nu = mySpectrum(nu), nu in Hz. Assumes optically thick regime.
virtual double | operator() (double nu, double opacity, double ds) const
| I_nu in optically thin regime.
virtual double | integrate (double nu1, double nu2)
| Integrate optically thick I_nu.
virtual void | set (std::string const &key, Value val)
virtual void | set (Property const &p, Value val)
| Set Value of a Property.
virtual void | set (Property const &p, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual void | set (std::string const &pname, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual Value | get (std::string const &key) const
virtual Value | get (Property const &p) const
| Get Value of a Property.
virtual Value | get (Property const &p, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual Value | get (std::string const &pname, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual int | setParameter (std::string name, std::string content, std::string unit)
virtual void | setParameter (Gyoto::Property const &p, std::string const &name, std::string const &content, std::string const &unit)
| Set parameter by Property (and name).
virtual void | fillElement (Gyoto::FactoryMessenger *fmp) const
void | setParameters (Gyoto::FactoryMessenger *fmp)
virtual bool | hasPythonProperty (std::string const &key) const
virtual void | setPythonProperty (std::string const &key, Value val)
virtual Value | getPythonProperty (std::string const &key) const
virtual int | pythonPropertyType (std::string const &key) const
virtual double | integrate (double nu1, double nu2, const Spectrum::Generic *opacity, double ds)
| Integrate optically thin I_nu.
void | incRefCount ()
| Increment the reference counter. Warning: Don't mess with the counter.
int | decRefCount ()
| Decrement the reference counter and return current value. Warning: Don't mess with the counter.
int | getRefCount ()
| Get the current number of references.
virtual bool | isThreadSafe () const
| Whether this class is thread-safe.
Property const * | property (std::string const pname) const
| Find property by name.
virtual void | fillProperty (Gyoto::FactoryMessenger *fmp, Property const &p) const
| Output a single Property to XML.
std::string | describeProperty (Gyoto::Property const &p) const
| Format desrciption for a property.
void | help () const
| Print (to stdout) some help on this class.
virtual std::string | kind () const
| Get kind_.

## Public Attributes

| GYOTO_OBJECT_THREAD_SAFETY

## Static Public Attributes

static GYOTO_OBJECT Property const | properties []

## Protected Member Functions

virtual void | kind (const std::string)
| Set kind_.

## Protected Attributes

PyObject * | pCall_
| Reference to ___call__.
PyObject * | pIntegrate_
| Reference to the (optional) integrate method.
bool | pCall_overloaded_
| Whether call is overloaded.
std::string | module_
| Name of the Python module that holds the class.
std::string | inline_module_
| Python source code for module that holds the class.
std::string | class_
| Name of the Python class that we want to expose.
std::vector< double > | parameters_
| Parameters that this class needs.
PyObject * | pModule_
| Reference to the python module once it has been loaded.
PyObject * | pInstance_
| Reference to the python instance once it has been instantiated.
PyObject * | pProperties_
| Reference to the properties member.
PyObject * | pSet_
| Reference to the (optional) Set method.
PyObject * | pGet_
| Reference to the (optional) Get method.
std::string | kind_
| The "kind" that is output in the XML entity.
std::vector< std::string > | plugins_
| The plug-ins that needs to be loaded to access this instance's class.

## Private Attributes

int | refCount
| Reference counter.
pthread_mutex_t | mutex_
| A mutex.

## Friends

class | Gyoto::SmartPointer< Gyoto::Spectrum::Python >

## Detailed Description

Loader for Python classes implementing the Spectrum interface.

It interfaces with a Python class which must implement at least the call method.

Sample XML file:

<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<Scenery>
The goal of this example is to exhibit using a Metric and a Spectrum
coded in Python. It is functionaly equivalent to
example-fixed-star-minkowski-cartesian.xml in the main Gyoto example
directory.
An optically thin blob centered on the origin of the coordinate
system, in flat space-time. Computation uses the Cartesian
coordinates.
<Metric kind = "Python">
<Mass unit="sunmass"> 4e6 </Mass>
<Cartesian/>
<Module>gyoto_sample_metrics</Module>
<Class>Minkowski</Class>
</Metric>
<Screen>
<Distance unit="kpc"> 8 </Distance>
<Time unit="yr"> 30e3 </Time>
<FieldOfView unit="microas"> 150 </FieldOfView>
In UTF-8 locales, "microas" may be written "µas".
<Inclination unit="degree"> 90 </Inclination>
In UTF-8 locales, "degree" may be written "°".
<PALN> 0 </PALN>
<Argument> 0 </Argument>
<Resolution> 32 </Resolution>
</Screen>
<Astrobj kind = "FixedStar">
<Radius> 12 </Radius>
<Position> 0 0 0 </Position>
<UseGenericImpact/>
<Spectrum kind="Python">
<Module>gyoto_sample_spectra</Module>
<Class>PowerLaw</Class>
<Constant>0.001</Constant>
<Exponent>0.</Exponent>
</Spectrum>
<Opacity kind="Python">
<Module>gyoto_sample_spectra</Module>
<Class>PowerLaw</Class>
<Constant>0.001</Constant>
<Exponent>0.</Exponent>
</Opacity>
<OpticallyThin/>
</Astrobj>
<Delta> 1e0 </Delta>
<MinimumTime> 0. </MinimumTime>
<Quantities>
Intensity
</Quantities>
One can also specify a unit (if Gyoto was compiled with --with-udunits):
Intensity[mJy/pix²]
Intensity[mJy/µas²]
Intensity[J.m-2.s-1.sr-1.Hz-1]
Intensity[erg.cm-2.s-1.sr-1.Hz-1]
Intensity[mJy.sr-1]
Intensity[Jy.sr-1]
</Scenery>

Sample Python module:

'''Sample spectra for using with Gyoto Python plug-in
Those classes demonstrate how to use Python classes as Gyoto
Spectrum implementations using Gyoto's "python" plug-in. Note that
this plug-in can be renamed to whatever matches the particular
version of Python it has been built against (e.g. python3.4).
The goal is to be able to instantiate these from XML, from
Yorick... and even from Python using the gyoto extension...
Synopsis:
import gyoto.core
gyoto.core.requirePlugin("python") # or python2.7 or python3.4...
sp=gyoto.core.Spectrum("Python")
sp.set("Module", "gyoto_sample_spectra")
sp.set("Class", "PowerLaw") # or "BlackBody6000"
sp.set("Parameters", (1., 2.))
val=sp(3e8/2e-6)
Classes that aim at implementing the Gyoto::Spectrum::Generic
interface do so by providing the following members and methods:
__call__(self, nu): mandatory;
__setitem__: optional;
integrate: optional;
properties, set, get: optional.
'''
import math
import numpy
import gyoto.core
class BlackBody6000:
'''Black-body spectrum at 6000K
Parameters: none.
This example is pretty minimal: it's a black-body with fixed
temperature. We implement the only mandaroty function:
__call__(self, nu).
'''
def __call__(self, nu):
'''spectrum(frequency_in_Hz) = black-body distribution for T=6000K.
This function implements only
Gyoto::Spectrum::Python::operator()(double nu).
It does so by not accepting the varargs argument. Contrast
with the PowerLaw definition of __call__.
'''
temperature=6000.
PLANCK_OVER_BOLTZMANN=4.7992373e-11
return nu*nu*nu/(math.exp(PLANCK_OVER_BOLTZMANN*nu/temperature)-1.);
class PowerLaw:
'''Powerlaw spectrum
Parameters: (constant, exponent)
This example is pretty complete. It implements everything usefull
and some eye-candy.
'''
constant=0.
exponent=0.
properties={"Constant": "double", "Exponent": "double"}
def __setitem__(self, key, value):
'''
This is how Gyoto sends the <Parameters/> XML entity:
spectrum[i]=value
i=0: set constant
i=1: set exponent
'''
if (key==0 or key == "Constant"):
self.constant = value
elif (key==1 or key == "Exponent"):
self.exponent = value
else:
raise IndexError
set=__setitem__
def get(self, key):
'''
Implementing this is absolutely not necessary (Gyoto does not
use it, as of now), but we can: it allows retrieving the
parameters like __setitem__ sets them:
spectrum[0] == spectrum.constant
spectrum[1] == spectrum.exponent
'''
if (key==0 or key=="Constant"):
return self.constant
elif (key==1 or key=="Exponent"):
return self.exponent
else:
raise IndexError
def __call__(self, *args):
'''spectrum(frequency_in_Hz) = constant * nu**exponent
This function implements both
Spectrum::Python::operator()(double nu).
and
Spectrum::Python::operator()(double nu, double opacity, double ds).
This behavior is obtained by having the varargs *args as
second argument instead of a normal variable.
The second overloaded function is here exactly the same as the
C++ generic implementation and therefore useless. It is here
to illustrate the API.
'''
nu=args[0]
if (len(args)==1):
return self.constant * math.pow(nu, self.exponent)
else:
opacity=args[1]
ds=args[2]
thickness=(opacity*ds)
if (thickness):
return self(nu) * (1.-math.exp(-thickness))
return 0.
def integrate(self, nu1, nu2):
'''
If present, this function implements
Gyoto::Spectrum::Python::integrate(double nu1, double nu2)
If absent, the generic integrator is used.
'''
if (self.exponent == -1.):
return self.constant * (math.log(nu2) -math.log(nu1))
return self.constant * (math.pow(nu2, self.exponent+1)- math.pow(nu1, self.exponent+1)) / (self.exponent+1)

## Member Typedef Documentation

## Subcontractor_t

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > Gyoto::SmartPointee::Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)

inherited

A subcontractor builds an object upon order from the Factory.

Various classes need to provide a subcontractor to be able to instantiate themselves upon order from the Factory. A subcontractor is a function (often a static member function) which accepts a pointer to a FactoryMessenger as unique parameter, communicates with the Factory using this messenger to read an XML description of the object to build, and returns this objet. SmartPointee::Subcontractor_t* is just generic enough a typedef to cast to and from other subcontractor types: Astrobj::Subcontractor_t, Metric::Subcontractor_t, Spectrum::Subcontractor_t. A subcontractor needs to be registered using the relevant Register() function: Astrobj::Register(), Metric::Register(), Spectrum::Register().

## Member Function Documentation

## clone()

virtual Python * Gyoto::Spectrum::Python::clone | ( |  | ) | const

virtual

Cloner.

Reimplemented from Gyoto::Spectrum::Generic.

## describeProperty()

std::string Gyoto::Object::describeProperty | ( | Gyoto::Property const & | p | ) | const

inherited

Format desrciption for a property.

Returns a string containing the name(s) and type of the property, as well as whether it supports unit.

## fillElement()

virtual void Gyoto::Python::Object< Gyoto::Spectrum::Generic >::fillElement | ( | Gyoto::FactoryMessenger * | fmp | ) | const

inline virtual inherited

Reimplemented from Gyoto::Object.

## fillProperty()

virtual void Gyoto::Object::fillProperty | ( | Gyoto::FactoryMessenger * | fmp,
|  | Property const & | p ) const

virtual inherited

Output a single Property to XML.

The base implementation decides what to do based on the p.type. The format matches how setParameters() an setParameter() would interpret the XML descition.

Overriding this method should be avoided, but makes sense in some cases (for instance Screen::fillProperty() selects a different unit for Distance based on its magnitude, so that stellar sizes are expressed in solar radii while smaller sizes can be expressed in meters and larger sizes in parsecs).

Overriding implementation should fall-back on calling the implementation in the direct parent class:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const ;
};
void B::fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const {
if (name=="Duff") fmp->doSomething();
else A::fillProperty(fmp, p);
}
Gyoto::FactoryMessenger
Factory / SmartPointee::Subcontractor_t interface.
Definition GyotoFactoryMessenger.h:92
Gyoto::Property
Property that can be set and got using standard methods.
Definition GyotoProperty.h:608

Reimplemented in Gyoto::Astrobj::DirectionalDisk, Gyoto::Astrobj::Disk3D, Gyoto::Astrobj::DynamicalDisk, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::NeutronStarModelAtmosphere, Gyoto::Astrobj::PatternDisk, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Star, Gyoto::Astrobj::XillverReflection, Gyoto::Metric::Shift, Gyoto::Scenery, Gyoto::Screen, and Gyoto::Spectrometer::Uniform.

## get()

virtual Value Gyoto::Python::Object< Gyoto::Spectrum::Generic >::get | ( | std::string const & | pname | ) | const

inline virtual inherited

Reimplemented from Gyoto::Object.

## getProperties()

virtual Property const * Gyoto::Spectrum::Python::getProperties | ( |  | ) | const

virtual

Get list of properties.

This method is declared automatically by the GYOTO_OBJECT macro and defined automatically by the GYOTO_PROPERTY_END macro.

Reimplemented from Gyoto::Spectrum::Generic.

## help()

void Gyoto::Object::help | ( |  | ) | const

inherited

Print (to stdout) some help on this class.

Describe all properties that this instance supports.

## inlineModule() [1/2]

virtual std::string Gyoto::Spectrum::Python::inlineModule | ( |  | ) | const

virtual

Return inline_module_.

Reimplemented from Gyoto::Python::Base.

## inlineModule() [2/2]

virtual void Gyoto::Spectrum::Python::inlineModule | ( | const std::string & |  | ) |

virtual

Set inline_module_ and import the Python module.

Side effects:

- sets module_ to "";
- calls klass(class_) if class_ is already known, so module_ can be set (or reset) after class_.

Reimplemented from Gyoto::Python::Base.

## integrate() [1/2]

virtual double Gyoto::Spectrum::Generic::integrate | ( | double | nu1,
|  | double | nu2,
|  | const Spectrum::Generic * | opacity,
|  | double | ds )

virtual inherited

Integrate optically thin I_nu.

See operator()(double nu, double opacity, double ds) const

Parameters

  nu1,nu2 | boundaries for the integration
  opacity | the frequency-dependent opacity law given as a pointer to a Gyoto::Spectrum::Generic sub-class instance
  ds | the element length for spatial integration

Returns
  I, the integral of I_nu between nu1 and nu2

## integrate() [2/2]

virtual double Gyoto::Spectrum::Python::integrate | ( | double | nu1,
|  | double | nu2 )

virtual

Integrate optically thick I_nu.

See operator()(double nu) const

Parameters

  nu1,nu2 | boundaries for the integration

Returns
  I, the integral of I_nu between nu1 and nu2

Reimplemented from Gyoto::Spectrum::Generic.

## isThreadSafe()

virtual bool Gyoto::Object::isThreadSafe | ( |  | ) | const

virtual inherited

Whether this class is thread-safe.

Return True if this object is thread-safe, i.e. if an instance and its clone can be used in parallel threads (in the context of Scenery::raytrace()). Known objects which are not thread-safe include Lorene metrics and everything from the Python plug-in.

The default implementation considers that the class itself is thread safe and recurses into the declared properties to check whether they are safe too. Classes that abide to the Object/Property paradigm and are themselves thread-safe have nothing special to do.

Objects that clone children in their copy constructor that are not declared as properties must take these children into account.

Classes that are never thread-safe must declare it. It acn be easily done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and GYOTO_PROPERTY_THREAD_UNSAFE in the class definition.

## kind() [1/2]

virtual std::string Gyoto::Object::kind | ( |  | ) | const

virtual inherited

Get kind_.

Reimplemented in Gyoto::Spectrometer::Uniform.

## kind() [2/2]

virtual void Gyoto::Object::kind | ( | const std::string |  | ) |

protected virtual inherited

Set kind_.

kind(const std::string) is protected because, for most Objects, it should not be changed in runtime. Set kind_

## klass() [1/2]

virtual std::string Gyoto::Spectrum::Python::klass | ( |  | ) | const

virtual

Retrieve class_.

Reimplemented from Gyoto::Python::Base.

## klass() [2/2]

virtual void Gyoto::Spectrum::Python::klass | ( | const std::string & | c | ) |

virtual

Set class_ and instantiate the Python class.

Sets pInstance_.

This generic implementation takes care of the common ground, but does not set 'this' or call parameters(parameters_). Therefore, all the derived classes should reimplement this method and at least call Python::Base::klass(c) and parameters(parameters_). Between the two is the right moment to check that the Python class implements the required API and to cache PyObject* pointers to class methods.

Reimplemented from Gyoto::Python::Base.

## module() [1/2]

virtual std::string Gyoto::Spectrum::Python::module | ( |  | ) | const

virtual

Return module_.

Reimplemented from Gyoto::Python::Base.

## module() [2/2]

virtual void Gyoto::Spectrum::Python::module | ( | const std::string & |  | ) |

virtual

Set module_ and import the Python module.

Side effects:

- sets inline_module_ to "";
- calls klass(class_) if class_ is already known, so module_ can be set (or reset) after class_.

Reimplemented from Gyoto::Python::Base.

## operator()() [1/2]

virtual double Gyoto::Spectrum::Python::operator() | ( | double | nu | ) | const

virtual

I_nu = mySpectrum(nu), nu in Hz. Assumes optically thick regime.

Implements Gyoto::Spectrum::Generic.

## operator()() [2/2]

virtual double Gyoto::Spectrum::Python::operator() | ( | double | nu,
|  | double | opacity,
|  | double | ds ) const

virtual

I_nu in optically thin regime.

Generic implementation assumes emissivity = opacity.

Parameters

  nu | frequency in Hz
  opacity | such that opacity*ds=optical thickness.
  ds | in geometrical units

Reimplemented from Gyoto::Spectrum::Generic.

## parameters() [1/2]

virtual std::vector< double > Gyoto::Spectrum::Python::parameters | ( |  | ) | const

virtual

Retrieve parameters_.

Reimplemented from Gyoto::Python::Base.

## parameters() [2/2]

virtual void Gyoto::Spectrum::Python::parameters | ( | const std::vector< double > & |  | ) |

virtual

Set parameters_ and send them to pInstance_.

The parameters are sent to the class instance using the setitem method with numerical keys.

Reimplemented from Gyoto::Python::Base.

## property()

Property const * Gyoto::Object::property | ( | std::string const | pname | ) | const

inherited

Find property by name.

Look into the Property list for a Property whose name (or name_false, for a boolean Property) is pname. Return a const pointer to the first such property found, or NULL if none is found.

## set()

virtual void Gyoto::Python::Object< Gyoto::Spectrum::Generic >::set | ( | std::string const & | pname,
|  | Value | val )

inline virtual inherited

Reimplemented from Gyoto::Object.

## setParameter() [1/2]

virtual void Gyoto::Object::setParameter | ( | Gyoto::Property const & | p,
|  | std::string const & | name,
|  | std::string const & | content,
|  | std::string const & | unit )

virtual inherited

Set parameter by Property (and name).

This function is used when parsing an XML description, if Property (p) of this name is found (i.e. either p.name or p.name_false is equal to name). Implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit);
};
void B::setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else A::setParameter(p, name, content, unit);
}

Parameters

  p | Property that matches name (p.name == name or p.name_false == name)
  name | XML name of the parameter (XML entity)
  content | string representation of the value
  unit | string representation of the unit

Reimplemented in Gyoto::Astrobj::PolishDoughnut.

## setParameter() [2/2]

virtual int Gyoto::Python::Object< Gyoto::Spectrum::Generic >::setParameter | ( | std::string | name,
|  | std::string | content,
|  | std::string | unit )

inline virtual inherited

Reimplemented from Gyoto::Object.

## setParameters()

void Gyoto::Python::Object< Gyoto::Spectrum::Generic >::setParameters | ( | Gyoto::FactoryMessenger * | fmp | ) |

inline virtual inherited

Reimplemented from Gyoto::Object.

## Member Data Documentation

## class_

std::string Gyoto::Python::Base::class_

protected inherited

Name of the Python class that we want to expose.

Property name: Class.

## kind_

std::string Gyoto::Object::kind_

protected inherited

The "kind" that is output in the XML entity.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj kind="kind_" ...>...</Astrobj>
Gyoto::Object::kind
virtual void kind(const std::string)
Set kind_.
Gyoto::Astrobj
Access to astronomical objects.
Definition GyotoAstrobj.h:49

is written.

## module_

std::string Gyoto::Python::Base::module_

protected inherited

Name of the Python module that holds the class.

For instance, if the class is implemented in toto.py, the module name is "toto". Property name: Module.

## mutex_

pthread_mutex_t Gyoto::SmartPointee::mutex_

private inherited

A mutex.

When compiled with libpthread

## parameters_

std::vector<double> Gyoto::Python::Base::parameters_

protected inherited

Parameters that this class needs.

A list of parameters (doubles) can be passed in the Property Parameters. They will be sent to the Python instance using setitem.

## pCall_

PyObject* Gyoto::Spectrum::Python::pCall_

protected

Reference to ___call__.

call is the method in the underlying Python class that implements Gyoto::Spectrum::Generic::operator()().

## pCall_overloaded_

bool Gyoto::Spectrum::Python::pCall_overloaded_

protected

Whether call is overloaded.

This is determined automatically by looking at the parameters accepted by call:

def __call__(self, nu)

In this case call is not overloaded and implements only virtual double operator()(double nu) const;

def __call__(self, *args)

In this case call is overloaded and implements both double operator()(double nu) const and virtual double operator()(double nu, double opacity, double ds) const.

## plugins_

std::vector<std::string> Gyoto::Object::plugins_

protected inherited

The plug-ins that needs to be loaded to access this instance's class.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj ... plugin="plugins_">...</Astrobj>

is written.

The documentation for this class was generated from the following file:

- GyotoPython.h